/** Source code example for "A Practical Introduction to Data
    Structures and Algorithm Analysis, 3rd Edition (Java)" 
    by Clifford A. Shaffer
    Copyright 2008-2011 by Clifford A. Shaffer
*/

class BPInternal<K,E> implements BPNode<K,E> { // Leaf node
  private int numrecords;
  private K theKeys[];
  private BPNode<K,E> thePointers[];

  public boolean isLeaf() { return true; }
  public int numrecs() { return numrecords; }
  public K[] keys() { return theKeys; }
  public BPInternal<K,E> add(BPInternal<K,E> ptr) { return null; }
  public boolean underflow(int which) { return false; }
  public BPNode<K,E> pointers(int which) { return thePointers[which]; }
};
