/** Source code example for "A Practical Introduction to Data
    Structures and Algorithm Analysis, 3rd Edition (Java)" 
    by Clifford A. Shaffer
    Copyright 2008-2011 by Clifford A. Shaffer
*/

public class SkipNode<K,E> {
  private E element;
  private K key;

  public SkipNode<K,E>[] forward;

  public E element() { return element; }
  public K key() { return key; }

  public SkipNode(K k, E r, int level) {
    key = k;
    element = r;
    forward = (SkipNode<K,E>[])new SkipNode[level+1];
    for (int i=0; i<level; i++)
      forward[i] = null;
  }
}
